#ifndef _KGR_PATCH_BSC1189278_H
#define _KGR_PATCH_BSC1189278_H

#if IS_ENABLED(CONFIG_X86_64)

int kgr_patch_bsc1189278_init(void);
void kgr_patch_bsc1189278_cleanup(void);


#include <linux/kvm_types.h>

int kgrp_ept_page_fault(struct kvm_vcpu *vcpu, gva_t addr, u32 error_code,
			     bool prefault);
int kgrp_paging64_page_fault(struct kvm_vcpu *vcpu, gva_t addr, u32 error_code,
			     bool prefault);
int kgrp_paging32_page_fault(struct kvm_vcpu *vcpu, gva_t addr, u32 error_code,
			     bool prefault);

#define KGR_PATCH_BSC1189278_FUNCS					\
	KGR_PATCH_OBJ(ept_page_fault, kgrp_ept_page_fault,		\
		      "kvm"),						\
	KGR_PATCH_OBJ(paging64_page_fault, kgrp_paging64_page_fault,	\
		      "kvm"),						\
	KGR_PATCH_OBJ(paging32_page_fault, kgrp_paging32_page_fault,	\
		      "kvm"),						\

#else /* !IS_ENABLED(CONFIG_X86_64) */

static inline int kgr_patch_bsc1189278_init(void) { return 0; }

static inline void kgr_patch_bsc1189278_cleanup(void) {}

#define KGR_PATCH_BSC1189278_FUNCS

#endif /* IS_ENABLED(CONFIG_X86_64) */
#endif /* _KGR_PATCH_BSC1189278_H */
